/*
 * This Groovy source file was generated by the Gradle 'init' task.
 */
package resume.gradle

import org.gradle.api.Plugin
import org.gradle.api.Project
import org.gradle.api.Task
import org.gradle.api.file.Directory
import org.gradle.api.plugins.BasePlugin
import org.gradle.api.plugins.JavaBasePlugin
import org.gradle.api.provider.Provider
import org.gradle.api.tasks.Copy
import org.gradle.api.tasks.bundling.Jar
import org.gradle.api.tasks.bundling.War

import resume.gradle.docx.RenderResumeDocx
import resume.gradle.dsl.ResumeDsl
import resume.gradle.html.RenderResumeHtml

/**
 * A Resume generator plugin for Gradle.
 */
public class ResumeGradlePlugin implements Plugin<Project> {

    static final String TASK_GROUP = 'Resume'

    /**
     * Most of what we do here happens in "Project Space," so we may 
     * as well delegate to it directly
     */
    @Delegate
    private Project _target

    private ResumeDsl _resume

    private Directory _outputDir

    /**
     *
     */
    public void apply(Project project) {
        _target = project

        //Ensure java life-cycle methods are present
        getPluginManager().apply(BasePlugin)
        getPluginManager().apply(JavaBasePlugin)

        //Hold a reference to the output directory
        _outputDir = getLayout().buildDirectory.dir('resume').get()

        //register the extension object and retain a reference
        _resume = getExtensions().create('resume', ResumeDsl)

        //allow the project to fully update before creating our render tasks
        afterEvaluate(this.&registerTasks)
    }

    ResumeModelMapper createResumeModelTask() {
        final ResumeModelMapper resumeModel = getTasks().create('resumeModel', ResumeModelMapper) {
            group = TASK_GROUP
            description = "Maps live model instance for incremental task inputs"
        }

        resumeModel.resume.set(_resume)
        return resumeModel
    }

    RenderResumeXmi createResumeXmiTask(final Provider<Map> modelProvider) {
        final RenderResumeXmi resumeXmi = getTasks().create('resumeXmi', RenderResumeXmi) {
            group = TASK_GROUP
            description = "Fully renders a serialized XMI respresentation of the model instance defined by the resume extension"
        }

        resumeXmi.modelProvider = modelProvider
        resumeXmi.resume.set(_resume)

        return resumeXmi
    }

    RenderResumeHtml createResumeHtmlTask(final Provider<Map> modelProvider) {
        final Directory templateDir = getLayout().projectDirectory.dir('src/main/resources/template')
        final RenderResumeHtml resumeHtml = getTasks().create('resumeHtml', RenderResumeHtml) {
            group = TASK_GROUP
            description = "Fully render the Resume document model as html"
        }

        resumeHtml.modelProvider = modelProvider
        resumeHtml.resume.set(_resume)
        resumeHtml.outputDir.set(_outputDir)
        resumeHtml.templateDir.set(templateDir.dir('html'))

        return resumeHtml
    }

    RenderResumeSkillCloud createResumeSkillCloudTask(final Provider<Map> modelProvider) {
        final RenderResumeSkillCloud resumeSkillCloud = getTasks().create('resumeSkillCloud', RenderResumeSkillCloud) {
            group = TASK_GROUP
            description = "Renders a 'Word Cloud' image from a weighted list of skills"
        }

        resumeSkillCloud.modelProvider = modelProvider
        resumeSkillCloud.resume.set(_resume)

        return resumeSkillCloud
    }

    RenderResumeDocx createResumeDocxTask(final Provider<Map> modelProvider) {
        final RenderResumeDocx resumeDocx = getTasks().create('resumeDocx', RenderResumeDocx) {
            group = TASK_GROUP
            description = "Fully render the Resume document model as word document"
        }

        resumeDocx.modelProvider = modelProvider
        resumeDocx.resume.set(_resume.getModel())

        return resumeDocx
    }

    Copy createProcessWebContentTask() {
        final Directory webContentDir = getLayout().projectDirectory.dir('src/main/resources/WebContent')
        final Copy processWebContent = getTasks().create('processWebContent', Copy) {
            group = TASK_GROUP
            description = "Copy any WebContent into the output directory"
        }
        processWebContent.from(webContentDir)
        processWebContent.into(_outputDir)
        processWebContent.setIncludeEmptyDirs(false)

        return processWebContent
    }


    void registerTasks() {

        // Register a task to hold the existing model data. We should take care
        // to ensure this task always runs
        final ResumeModelMapper resumeModel = createResumeModelTask()

        // register a task to render the model as XMI
        final RenderResumeXmi resumeXmi = createResumeXmiTask(resumeModel.modelProvider)
        resumeXmi.dependsOn(resumeModel)

        // Register a task to render the resume as html
        final RenderResumeHtml resumeHtml = createResumeHtmlTask(resumeModel.modelProvider)
        resumeHtml.dependsOn(resumeModel)


        // Register a task to create the word document
        final RenderResumeSkillCloud resumeSkillCloud = createResumeSkillCloudTask(resumeModel.modelProvider)
        resumeSkillCloud.dependsOn(resumeModel)

        // Register a task to render the resume as a word doc
        final RenderResumeDocx resumeDocx = createResumeDocxTask(resumeModel.modelProvider)
        resumeDocx.skillCloudFile.set(resumeSkillCloud.outputFile)
        resumeDocx.dependsOn(resumeModel, resumeSkillCloud)

        // Register a copy task to publish WebContent
        final Copy processWebContent = createProcessWebContentTask()

        // Exclude WebContent from resources since we include it from the build directory bellow
        final Copy processResources = getTasks().findByPath('processResources')
        if(processResources) {
            processResources.setIncludeEmptyDirs(false)
            processResources.exclude('WebContent/*')
        }


        // If the war plugin is present, append resume to the war
        final War war = getTasks().findByPath('war')
        if(war) {
            war.from(resumeXmi, resumeHtml, resumeDocx, resumeSkillCloud, processWebContent)
        }
        else {
            //if there is no war plugin, but a jar plugin, append it there
            final Jar jar = getTasks().findByPath('jar')
            if(jar) {
                jar.from(resumeXmi, resumeHtml, resumeDocx, resumeSkillCloud, processWebContent)
            }
        }


        //Register tasks to run in build life-cycle
        final Task build = getTasks().getByName('build')
        build.dependsOn(resumeXmi, resumeHtml, processWebContent, resumeSkillCloud)
    }
}
